"use strict"

var createOrbitCamera = require("orbit-camera")

function attachCamera(shell) {
  var camera = createOrbitCamera()
  shell.on("tick", function() {
    var ctrl   = shell.down("control")
    var alt    = shell.down("shift")
    var left   = shell.down("mouse-left")
    var right  = shell.down("mouse-right")
    var middle = shell.down("mouse-middle")
    if(left && !ctrl && !alt) {
      camera.rotate([shell.mouseX/shell.width-0.5, shell.mouseY/shell.height-0.5],
                    [shell.prevMouseX/shell.width-0.5, shell.prevMouseY/shell.height-0.5])
    }
    if(right || (left && ctrl && !alt)) {
      camera.pan([(shell.mouseX - shell.prevMouseX)/shell.width,
                  (shell.mouseY - shell.prevMouseY)/shell.height])
    }
    if(shell.scroll[1]) {
      camera.distance *= Math.exp(shell.scroll[1] / shell.height)
    }
    if(middle || (left && !ctrl && alt)) {
      var d = shell.mouseY - shell.prevMouseY
      if(d) {
        camera.distance *= Math.exp(d / shell.height)
      }
    }
  })
  
  return camera
}

module.exports = attachCamera